<template>
  <div
    class="displacement-status"
    :class="`displacement-status-${isShuttle ? shuttleClass : rideClass}`"
  >
    <template
      v-if="isShuttle && !['planifié', 'disponible'].includes(shuttleTitle)"
    >
      {{ shuttleTitle[0] }}
      <fa-icon icon="arrow-right" />
      {{ shuttleTitle[1] }}
    </template>
    <template v-else>
      {{ isShuttle ? shuttleTitle : rideTitle }}
    </template>
  </div>
</template>

<script>
import {
  DELIVERED, IN_PROGRESS, WAITING, STARTED, ACCEPTED, VALIDATED, CREATED,
} from '@fabnumdef/e-chauffeur_lib-vue/api/status/states';

export default {
  props: {
    displacement: {
      type: Object,
      default: () => ({}),
    },
    isAvailable: {
      type: Boolean,
      default: false,
    },
  },
  computed: {
    isShuttle() {
      return !!this.displacement.shuttleFactory;
    },
    rideTitle() {
      if (!this.displacement) {
        return 'Disponible';
      }
      if (!this.isAvailable) {
        return 'Pas en service';
      }
      switch (this.displacement.status) {
        case VALIDATED:
        case ACCEPTED:
          return 'Planifié';
        case STARTED:
          return 'En route';
        case WAITING:
          return 'En attente';
        case IN_PROGRESS:
          return 'En route';
        case DELIVERED:
        default:
          return 'Disponible';
      }
    },

    rideClass() {
      if (!this.displacement) {
        return 'available';
      }
      if (!this.isAvailable) {
        return 'unavailable';
      }
      switch (this.displacement.status) {
        case WAITING:
          return 'waiting';
        case STARTED:
        case IN_PROGRESS:
          return 'driving';
        case ACCEPTED:
          return 'accepted';
        case VALIDATED:
          return 'planned';
        case DELIVERED:
        default:
          return 'available';
      }
    },

    shuttleTitle() {
      const { currentStopIndex } = this.displacement;

      if (!this.displacement) {
        return 'Disponible';
      }

      if (!this.isAvailable) {
        return 'Pas en service';
      }

      switch (this.displacement.status) {
        case CREATED:
          return 'planifié';
        case STARTED:
          if (currentStopIndex === this.displacement.shuttleFactory.stops.length - 1) {
            return 'disponible';
          }
          return [
            this.displacement.shuttleFactory.stops[currentStopIndex].poiId,
            this.displacement.shuttleFactory.stops[currentStopIndex + 1].poiId,
          ];
        default:
          return 'disponible';
      }
    },
    shuttleClass() {
      if (!this.displacement) {
        return 'available';
      }
      if (!this.isAvailable) {
        return 'unavailable';
      }
      switch (this.displacement.status) {
        case CREATED:
          return 'planned';
        case STARTED:
          return 'driving';
        case DELIVERED:
        default:
          return 'available';
      }
    },
  },
};
</script>
<style scoped lang="scss">
  @import "~assets/css/head";

  .displacement-status {
    padding: 0 5px;
    width: 100%;
    font-weight: bold;
    display: inline-block;
    text-transform: uppercase;
    &-available {
      background: $success;
      color: findColorInvert($success);
    }
    &-unavailable {
      background: $gray;
      color: findColorInvert($gray);
    }
    &-planned {
      background: repeating-linear-gradient(45deg, rgba(195, 195, 195, 0.85), rgba(195, 195, 195, 0.85) 1px,
        #8192A9 1px, #8192A9 20px);
      color: findColorInvert($dark-gray);
    }
    &-accepted {
      background: #8192A9;
      color: findColorInvert($primary);
    }
    &-driving {
      background: $primary;
      color: findColorInvert($primary);
    }
    &-waiting{
      background: $warning;
      color: findColorInvert($warning);
    }
  }
</style>
